Index: trunk/compiler/ooasCompiler/src/org/momut/ooas/codegen/ast/OoaAstEmitter.java
===================================================================
--- trunk/compiler/ooasCompiler/src/org/momut/ooas/codegen/ast/OoaAstEmitter.java	(revision 8)
+++ trunk/compiler/ooasCompiler/src/org/momut/ooas/codegen/ast/OoaAstEmitter.java	(revision 9)
@@ -44,7 +44,6 @@
 import org.momut.ooas.ast.expressions.ListConstructor;
 import org.momut.ooas.ast.expressions.MapConstructor;
 import org.momut.ooas.ast.expressions.ObjectConstructor;
-import org.momut.ooas.ast.expressions.QValConstructor;
 import org.momut.ooas.ast.expressions.Quantifier;
 import org.momut.ooas.ast.expressions.SetConstructor;
 import org.momut.ooas.ast.expressions.TernaryOperator;
@@ -62,7 +61,6 @@
 import org.momut.ooas.ast.identifiers.Identifier;
 import org.momut.ooas.ast.identifiers.IdentifierKind;
 import org.momut.ooas.ast.identifiers.IdentifierList;
-import org.momut.ooas.ast.identifiers.LandmarkIdentifier;
 import org.momut.ooas.ast.identifiers.LocalVariableIdentifier;
 import org.momut.ooas.ast.identifiers.MainModule;
 import org.momut.ooas.ast.identifiers.MethodIdentifier;
@@ -83,7 +81,6 @@
 import org.momut.ooas.ast.statements.KillStatement;
 import org.momut.ooas.ast.statements.NondetBlock;
 import org.momut.ooas.ast.statements.PrioBlock;
-import org.momut.ooas.ast.statements.QualitativeConstraintStatement;
 import org.momut.ooas.ast.statements.SeqBlock;
 import org.momut.ooas.ast.statements.SkipStatement;
 import org.momut.ooas.ast.statements.Statement;
@@ -100,10 +97,9 @@
 import org.momut.ooas.ast.types.OoActionSystemInstance;
 import org.momut.ooas.ast.types.OoActionSystemType;
 import org.momut.ooas.ast.types.OpaqueType;
-import org.momut.ooas.ast.types.QrType;
 import org.momut.ooas.ast.types.TupleType;
 import org.momut.ooas.ast.types.TypeKind;
-import org.momut.ooas.ast.types.UlyssesType;
+import org.momut.ooas.ast.types.Type;
 import org.momut.ooas.ast.types.ValuedEnumType;
 import org.momut.ooas.parser.ParserState;
 import org.momut.ooas.utils.exceptions.NotImplementedException;
@@ -116,7 +112,7 @@
 	final ParserState m_state;
 	protected HashSet<Object> m_visited = new HashSet<Object>();
 	final IdentityHashMap<Identifier,T> m_convertedIdentifiers;
-	final IdentityHashMap<UlyssesType,T> m_convertedTypes;
+	final IdentityHashMap<Type,T> m_convertedTypes;
 	final IdentityHashMap<Expression,T> m_convertedExpressions;
 	final IdentityHashMap<Statement,T> m_convertedStatements;
 	final IdentityHashMap<IScope,T> m_convertedScopes;
@@ -173,7 +169,7 @@
 		return result;
 	}
 
-	private final T createType(UlyssesType type) {
+	private final T createType(Type type) {
 		TypeKind kind = type.kind();
 		if (type instanceof ValuedEnumType)
 			kind = TypeKind.ValuedEnumeratedType;
@@ -657,11 +653,11 @@
 
 		final Identifier id = tupleType.identifier();
 		VisitSub(id, tupleType);
-		for (final UlyssesType t: tupleType.innerTypes())
+		for (final Type t: tupleType.innerTypes())
 			VisitSub(t, tupleType);
 
 		final T list = m_copier.createTypeList();
-		for (final UlyssesType t: tupleType.innerTypes())
+		for (final Type t: tupleType.innerTypes())
 			m_copier.addTypeToList(list, m_convertedTypes.get(t));
 
 		m_copier.initTupleType(
@@ -678,13 +674,13 @@
 
 		final Identifier id = functionType.identifier();
 		VisitSub(id, functionType);
-		for (final UlyssesType a: functionType.parameter())
+		for (final Type a: functionType.parameter())
 			VisitSub(a, functionType);
 		VisitSub(functionType.returnType(), functionType);
 
 
 		final T list = m_copier.createTypeList();
-		for (final UlyssesType t: functionType.parameter())
+		for (final Type t: functionType.parameter())
 			m_copier.addTypeToList(list, m_convertedTypes.get(t));
 
 		m_copier.initFunctionType(
@@ -1449,32 +1445,4 @@
 		// maps are not supported right now
 		throw new NotImplementedException();
 	}
-
-	@Override
-	public  void visit(QrType qrType)
-	{
-		// QR is never going to be supported again.
-		throw new NotImplementedException();
-	}
-
-	@Override
-	public void visit(QValConstructor qValConstructor)
-	{
-		// we do not support qualitative systems anymore
-		throw new NotImplementedException();
-	}
-
-	@Override
-	public void visit(QualitativeConstraintStatement qalitativeConstraintStatement)
-	{
-		// we do not support qualitative systems anymore
-		throw new NotImplementedException();
-	}
-
-	@Override
-	public void visit(LandmarkIdentifier landmarkIdentifier)
-	{
-		// we do not support qualitative systems anymore
-		throw new NotImplementedException();
-	}
 }
Index: trunk/compiler/ooasCompiler/src/org/momut/ooas/codegen/cadp/CadpStatement.java
===================================================================
--- trunk/compiler/ooasCompiler/src/org/momut/ooas/codegen/cadp/CadpStatement.java	(revision 8)
+++ trunk/compiler/ooasCompiler/src/org/momut/ooas/codegen/cadp/CadpStatement.java	(revision 9)
@@ -53,7 +53,7 @@
 import org.momut.ooas.ast.types.FunctionType;
 import org.momut.ooas.ast.types.IntType;
 import org.momut.ooas.ast.types.ListType;
-import org.momut.ooas.ast.types.UlyssesType;
+import org.momut.ooas.ast.types.Type;
 import org.momut.ooas.codegen.OoasCodeEmitter;
 import org.momut.ooas.visitors.OoaPrintVisitor;
 import org.momut.ooas.visitors.OoaStatementVisitor;
@@ -317,7 +317,7 @@
 		m_emitter.AppendLineIncIndent("{");
 		m_emitter.AppendLine("oldState = (CAESAR_TYPE_STATE) elems->aState;");
 
-		final ArrayList<SimpleEntry<String, UlyssesType>> nondetEnumerators = new ArrayList<>();
+		final ArrayList<SimpleEntry<String, Type>> nondetEnumerators = new ArrayList<>();
 		if (assignment.symbols().symbolList().size() > 0)
 		{
 			for (final Identifier sym : assignment.symbols().symbolList())
@@ -327,16 +327,16 @@
 				sym.type().Accept(typevis);
 				sym.Accept(idvis);
 				m_emitter.AppendLine(String.format("%1$s %2$s; /* unbound in expression */", typevis.ToString(), idvis.toString()));
-				nondetEnumerators.add(new SimpleEntry<String, UlyssesType>(idvis.toString(), sym.type()));
+				nondetEnumerators.add(new SimpleEntry<String, Type>(idvis.toString(), sym.type()));
 			}
 		}
 
 		if (assignment.nondetExpression() != null)
 		{
-			for (final SimpleEntry<String, UlyssesType> key : nondetEnumerators)
+			for (final SimpleEntry<String, Type> key : nondetEnumerators)
 			{
 				m_emitter.AppendLine(String.format("for (%1$s = %2$s; %1$s <= %3$s; %1$s++) ",
-						key.getKey(), UlyssesType.Low(key.getValue()), UlyssesType.High(key.getValue())));
+						key.getKey(), Type.Low(key.getValue()), Type.High(key.getValue())));
 				m_emitter.AppendLineIncIndent("{");
 			}
 
@@ -406,7 +406,7 @@
 		m_emitter.AppendLine(String.format("LIST_INSERT_SINGLELIST(%1$s,newListElem);", m_procInfo.doneListString));
 		m_emitter.AppendLine("}");
 		if (assignment.nondetExpression() != null)
-			for (@SuppressWarnings("unused") final SimpleEntry<String, UlyssesType> key : nondetEnumerators)
+			for (@SuppressWarnings("unused") final SimpleEntry<String, Type> key : nondetEnumerators)
 				m_emitter.AppendLine("} /* closing nondet assignment for loop */");
 
 		m_emitter.AppendLine("elems = elems->next;");
Index: trunk/compiler/ooasCompiler/src/org/momut/ooas/codegen/java/JavaExpression.java
===================================================================
--- trunk/compiler/ooasCompiler/src/org/momut/ooas/codegen/java/JavaExpression.java	(revision 8)
+++ trunk/compiler/ooasCompiler/src/org/momut/ooas/codegen/java/JavaExpression.java	(revision 9)
@@ -39,7 +39,6 @@
 import org.momut.ooas.ast.expressions.ListConstructor;
 import org.momut.ooas.ast.expressions.MapConstructor;
 import org.momut.ooas.ast.expressions.ObjectConstructor;
-import org.momut.ooas.ast.expressions.QValConstructor;
 import org.momut.ooas.ast.expressions.SetConstructor;
 import org.momut.ooas.ast.expressions.TernaryOperator;
 import org.momut.ooas.ast.expressions.TupleConstructor;
@@ -48,14 +47,11 @@
 import org.momut.ooas.ast.expressions.UnaryOperator;
 import org.momut.ooas.ast.expressions.UnresolvedIdentifierExpression;
 import org.momut.ooas.ast.expressions.ValueExpression;
-import org.momut.ooas.ast.expressions.QValConstructor.QValDeriv;
 import org.momut.ooas.ast.identifiers.EnumIdentifier;
 import org.momut.ooas.ast.identifiers.Identifier;
 import org.momut.ooas.ast.identifiers.IdentifierKind;
-import org.momut.ooas.ast.identifiers.LandmarkIdentifier;
-import org.momut.ooas.ast.types.QrType;
 import org.momut.ooas.ast.types.TypeKind;
-import org.momut.ooas.ast.types.UlyssesType;
+import org.momut.ooas.ast.types.Type;
 import org.momut.ooas.codegen.OoasCodeEmitter;
 import org.momut.ooas.utils.UnsignedHelper;
 import org.momut.ooas.utils.exceptions.NotImplementedException;
@@ -176,14 +172,6 @@
 	@Override
 	public void visit(IdentifierExpression identifierExpression)
 	{
-		if (identifierExpression.identifier().kind() == IdentifierKind.LandmarkIdentifier)
-		{
-			final LandmarkIdentifier lmid = (LandmarkIdentifier)identifierExpression.identifier();
-			final QrType qr = (QrType)lmid.type();
-			m_emitter.Append(qr.landmarks().indexOf(lmid));
-			return;
-		}
-
 		if (identifierExpression.identifier().kind() == IdentifierKind.EnumIdentifier)
 		{
 			m_emitter.Append(GetIdentifierString(((EnumIdentifier)identifierExpression.identifier()).type().identifier().tokenText()));
@@ -241,9 +229,9 @@
 					helperEmitter.AppendLine(String.format("for (%s %s = %s; %s <= %s; %s++) {",
 							atype.toString(),
 							JavaIdentifier.GetIdentifierString(sym.tokenText()),
-							UlyssesType.Low(sym.type()),
+							Type.Low(sym.type()),
 							JavaIdentifier.GetIdentifierString(sym.tokenText()),
-							UlyssesType.High(sym.type()),
+							Type.High(sym.type()),
 							JavaIdentifier.GetIdentifierString(sym.tokenText())));
 				else
 					throw new NotImplementedException();
@@ -326,36 +314,6 @@
 	}
 
 	@Override
-	public void visit(QValConstructor qValConstructor)
-	{
-		final StringBuilder helpers = new StringBuilder();
-
-		String landmarkOne = "null";
-		if (qValConstructor.value().length >= 1 && qValConstructor.value()[0] != null)
-		{
-			final JavaExpression lndmrk1 = new JavaExpression(helpers, m_data);
-			qValConstructor.value()[0].Accept(lndmrk1);
-			landmarkOne = lndmrk1.toString();
-		}
-		String landmarkTwo = "null";
-		if (qValConstructor.value().length >= 2 && qValConstructor.value()[1] != null)
-		{
-			final JavaExpression lndmrk = new JavaExpression(helpers, m_data);
-			qValConstructor.value()[1].Accept(lndmrk);
-			landmarkTwo = lndmrk.toString();
-		}
-		String derivation = "null";
-		if (qValConstructor.valueDeriv() != QValDeriv.DonTCare)
-		{
-			derivation = Integer.toString(qValConstructor.valueDeriv().ordinal());
-			//derivation = Enum.Format(typeof(QValDeriv), qValConstructor.valueDeriv, "d");
-		}
-
-		m_helpers.append(helpers.toString());
-		m_emitter.Append(String.format("new QualitativeValue(%s,%s,%s)", landmarkOne, landmarkTwo, derivation));
-	}
-
-	@Override
 	public void visit(AccessExpression accessExpression)
 	{
 		if (accessExpression.left().type().kind() != TypeKind.QrType &&
Index: trunk/compiler/ooasCompiler/src/org/momut/ooas/ast/expressions/Expression.java
===================================================================
--- trunk/compiler/ooasCompiler/src/org/momut/ooas/ast/expressions/Expression.java	(revision 8)
+++ trunk/compiler/ooasCompiler/src/org/momut/ooas/ast/expressions/Expression.java	(revision 9)
@@ -40,7 +40,7 @@
 import org.momut.ooas.ast.types.FloatType;
 import org.momut.ooas.ast.types.IntType;
 import org.momut.ooas.ast.types.TypeKind;
-import org.momut.ooas.ast.types.UlyssesType;
+import org.momut.ooas.ast.types.Type;
 import org.momut.ooas.ast.types.ValuedEnumType;
 import org.momut.ooas.math.AbstractOperations;
 import org.momut.ooas.math.AbstractRange;
@@ -81,7 +81,7 @@
 public abstract class Expression extends AstNode implements IAst
 {
 	protected ExpressionKind m_kind;
-	protected UlyssesType m_type;
+	protected Type m_type;
 	protected int m_line;
 	protected int m_pos;
 	protected SymbolTable m_freeVariables;
@@ -88,7 +88,7 @@
 	protected ArrayList<FunctionIdentifier> m_callTargets;
 
 	public ExpressionKind kind() { return m_kind; }
-	public UlyssesType type() { return m_type; }
+	public Type type() { return m_type; }
 	public int line() { return m_line; }
 	public int pos() { return m_pos; }
 	public SymbolTable freeVariables() { return m_freeVariables; }
@@ -117,7 +117,7 @@
 		throw new NotImplementedException();
 	}
 
-	public void SetType(UlyssesType aType)
+	public void SetType(Type aType)
 	{
 		if (aType == null)
 			throw new ArgumentException();
@@ -158,7 +158,7 @@
 	/// This is different from the cover-method defined at the type level.
 	/// Note: We do saturating operations on the type boundaries.
 	/// </summary>
-	public static UlyssesType ArithmeticCover(UlyssesType type1, UlyssesType type2, ExpressionKind op)
+	public static Type ArithmeticCover(Type type1, Type type2, ExpressionKind op)
 	{
 		if (!type1.IsNumeric() || (type2 != null && !type2.IsNumeric()))
 			throw new ArgumentException();
Index: trunk/compiler/ooasCompiler/src/org/momut/ooas/ast/expressions/ExpressionKind.java
===================================================================
--- trunk/compiler/ooasCompiler/src/org/momut/ooas/ast/expressions/ExpressionKind.java	(revision 8)
+++ trunk/compiler/ooasCompiler/src/org/momut/ooas/ast/expressions/ExpressionKind.java	(revision 9)
@@ -52,7 +52,8 @@
 	/*unary quantors*/
 	forall(47), exists(48),
 	/*Constructors*/
-	ListConstr(49), SetConstr(50), MapConstr(51), TupleConstr(52), ObjectConstr(53), QValConstr(54),
+	ListConstr(49), SetConstr(50), MapConstr(51), TupleConstr(52), ObjectConstr(53),
+	// QValConstr(54), -- no longer supported
 	/* identifier */
 	Identifier(55), UnresolvedIdentifier(56), Type(57),
 	/* tuple access and method call */
Index: trunk/compiler/ooasCompiler/src/org/momut/ooas/ast/expressions/ObjectConstructor.java
===================================================================
--- trunk/compiler/ooasCompiler/src/org/momut/ooas/ast/expressions/ObjectConstructor.java	(revision 8)
+++ trunk/compiler/ooasCompiler/src/org/momut/ooas/ast/expressions/ObjectConstructor.java	(revision 9)
@@ -33,7 +33,7 @@
 import org.momut.ooas.ast.IAstVisitor;
 import org.momut.ooas.ast.types.OoActionSystemInstance;
 import org.momut.ooas.ast.types.OpaqueType;
-import org.momut.ooas.ast.types.UlyssesType;
+import org.momut.ooas.ast.types.Type;
 
 public final class ObjectConstructor extends TypeConstructionExpression
 {
@@ -71,7 +71,7 @@
 		m_fixedObjectName = cleanup(aName);
 	}
 
-	public ObjectConstructor(UlyssesType aType, String aName, int line, int pos)
+	public ObjectConstructor(Type aType, String aName, int line, int pos)
 	{
 		super (ExpressionKind.ObjectConstr, line, pos);
 		SetType(aType);
Index: trunk/compiler/ooasCompiler/src/org/momut/ooas/ast/expressions/TypeExpression.java
===================================================================
--- trunk/compiler/ooasCompiler/src/org/momut/ooas/ast/expressions/TypeExpression.java	(revision 8)
+++ trunk/compiler/ooasCompiler/src/org/momut/ooas/ast/expressions/TypeExpression.java	(revision 9)
@@ -28,7 +28,7 @@
 package org.momut.ooas.ast.expressions;
 
 import org.momut.ooas.ast.IAstVisitor;
-import org.momut.ooas.ast.types.UlyssesType;
+import org.momut.ooas.ast.types.Type;
 
 ///////////////////////////////////////////////
 ///  Some identifier
@@ -35,7 +35,7 @@
 ///
 public class TypeExpression extends LeafExpression
 {
-	public TypeExpression(UlyssesType atype, int line, int pos)
+	public TypeExpression(Type atype, int line, int pos)
 	{
 		super (LeafTypeEnum.type, ExpressionKind.Type, line, pos);
 		m_type = atype;
Index: trunk/compiler/ooasCompiler/src/org/momut/ooas/ast/expressions/UnaryOperator.java
===================================================================
--- trunk/compiler/ooasCompiler/src/org/momut/ooas/ast/expressions/UnaryOperator.java	(revision 8)
+++ trunk/compiler/ooasCompiler/src/org/momut/ooas/ast/expressions/UnaryOperator.java	(revision 9)
@@ -28,7 +28,7 @@
 package org.momut.ooas.ast.expressions;
 
 import org.momut.ooas.ast.IAstVisitor;
-import org.momut.ooas.ast.types.UlyssesType;
+import org.momut.ooas.ast.types.Type;
 import org.momut.ooas.utils.exceptions.ArgumentException;
 
 
@@ -70,7 +70,7 @@
 		visitor.visit(this);
 	}
 
-	public static Expression CoerceUp(Expression anExpr, UlyssesType target)
+	public static Expression CoerceUp(Expression anExpr, Type target)
 	{
 		if (target == null)
 			throw new ArgumentException();
@@ -77,7 +77,7 @@
 
 		if (anExpr.kind() == ExpressionKind.Value
 				&& anExpr.type().kind() == target.kind()
-				&& UlyssesType.TypeEqual(UlyssesType.CoverType(anExpr.type(), target),target))
+				&& Type.TypeEqual(Type.CoverType(anExpr.type(), target),target))
 		{
 			// if we are widening the range of a type assigned to a value, then just set the
 			// new type and skip constructing a new node.
@@ -92,9 +92,9 @@
 		}
 	}
 
-	public static Expression TryCoerceUp(Expression anExpr, UlyssesType target)
+	public static Expression TryCoerceUp(Expression anExpr, Type target)
 	{
-		if (!UlyssesType.TypeEqual(anExpr.type(), target))
+		if (!Type.TypeEqual(anExpr.type(), target))
 		{
 			return CoerceUp(anExpr, target);
 		}
Index: trunk/compiler/ooasCompiler/src/org/momut/ooas/ast/expressions/ValueExpression.java
===================================================================
--- trunk/compiler/ooasCompiler/src/org/momut/ooas/ast/expressions/ValueExpression.java	(revision 8)
+++ trunk/compiler/ooasCompiler/src/org/momut/ooas/ast/expressions/ValueExpression.java	(revision 9)
@@ -28,7 +28,6 @@
 package org.momut.ooas.ast.expressions;
 
 import org.momut.ooas.ast.IAstVisitor;
-import org.momut.ooas.ast.types.QrType;
 import org.momut.ooas.utils.exceptions.ArgumentException;
 
 ///////////////////////////////////////////////
@@ -54,8 +53,6 @@
 			m_valueType = LeafTypeEnum.real;
 		else if (Character.class.isAssignableFrom(clazz))
 			m_valueType = LeafTypeEnum.chr;
-		else if (QrType.class.isAssignableFrom(clazz))
-			m_valueType = LeafTypeEnum.qval;
 		else if (Object.class.isAssignableFrom(clazz))
 			m_valueType = LeafTypeEnum.reference;
 		else
Index: trunk/compiler/ooasCompiler/src/org/momut/ooas/ast/identifiers/AttributeIdentifier.java
===================================================================
--- trunk/compiler/ooasCompiler/src/org/momut/ooas/ast/identifiers/AttributeIdentifier.java	(revision 8)
+++ trunk/compiler/ooasCompiler/src/org/momut/ooas/ast/identifiers/AttributeIdentifier.java	(revision 9)
@@ -32,7 +32,7 @@
 import org.momut.ooas.ast.IAstVisitor;
 import org.momut.ooas.ast.IScope;
 import org.momut.ooas.ast.expressions.Expression;
-import org.momut.ooas.ast.types.UlyssesType;
+import org.momut.ooas.ast.types.Type;
 import org.momut.ooas.utils.exceptions.ArgumentException;
 
 public final class AttributeIdentifier extends ValueReferenceIdentifier
@@ -48,7 +48,7 @@
 	public boolean isControllable() { return m_isControllable; }
 
 	public AttributeIdentifier(Token aToken,
-			UlyssesType aType,
+			Type aType,
 			IScope aDefiningScope,
 			Expression anInitializer,
 			boolean isStatic,
@@ -63,7 +63,7 @@
 	}
 
 	public AttributeIdentifier(String name,
-			UlyssesType aType,
+			Type aType,
 			IScope aDefiningScope,
 			Expression anInitializer,
 			boolean isStatic,
Index: trunk/compiler/ooasCompiler/src/org/momut/ooas/ast/identifiers/ExpressionVariableIdentifier.java
===================================================================
--- trunk/compiler/ooasCompiler/src/org/momut/ooas/ast/identifiers/ExpressionVariableIdentifier.java	(revision 8)
+++ trunk/compiler/ooasCompiler/src/org/momut/ooas/ast/identifiers/ExpressionVariableIdentifier.java	(revision 9)
@@ -30,7 +30,7 @@
 import org.antlr.runtime.Token;
 import org.momut.ooas.ast.IAstVisitor;
 import org.momut.ooas.ast.IScope;
-import org.momut.ooas.ast.types.UlyssesType;
+import org.momut.ooas.ast.types.Type;
 
 public final class ExpressionVariableIdentifier extends LocalVariableIdentifier
 {
@@ -39,7 +39,7 @@
 	public boolean initialized() { return m_isInitialized; }
 
 	public ExpressionVariableIdentifier(Token aToken,
-			UlyssesType aType,
+			Type aType,
 			IScope aDefiningScope)
 	{
 		super (aToken, aType, aDefiningScope);
Index: trunk/compiler/ooasCompiler/src/org/momut/ooas/ast/identifiers/FunctionIdentifier.java
===================================================================
--- trunk/compiler/ooasCompiler/src/org/momut/ooas/ast/identifiers/FunctionIdentifier.java	(revision 8)
+++ trunk/compiler/ooasCompiler/src/org/momut/ooas/ast/identifiers/FunctionIdentifier.java	(revision 9)
@@ -34,7 +34,7 @@
 import org.antlr.runtime.Token;
 import org.momut.ooas.ast.IScope;
 import org.momut.ooas.ast.statements.Statement;
-import org.momut.ooas.ast.types.UlyssesType;
+import org.momut.ooas.ast.types.Type;
 import org.momut.ooas.utils.exceptions.InternalCompilerException;
 
 public abstract class FunctionIdentifier extends Scope
@@ -47,7 +47,7 @@
 
 
 	public FunctionIdentifier(Token aToken,
-			UlyssesType aType,
+			Type aType,
 			IdentifierKind aKind,
 			IScope aDefiningScope)
 	{
@@ -63,7 +63,7 @@
 
 	public FunctionIdentifier(
 			String name,
-			UlyssesType aType,
+			Type aType,
 			IdentifierKind aKind,
 			IScope aDefiningScope)
 	{
Index: trunk/compiler/ooasCompiler/src/org/momut/ooas/ast/identifiers/Identifier.java
===================================================================
--- trunk/compiler/ooasCompiler/src/org/momut/ooas/ast/identifiers/Identifier.java	(revision 8)
+++ trunk/compiler/ooasCompiler/src/org/momut/ooas/ast/identifiers/Identifier.java	(revision 9)
@@ -33,7 +33,7 @@
 import org.momut.ooas.ast.IAst;
 import org.momut.ooas.ast.IAstVisitor;
 import org.momut.ooas.ast.IScope;
-import org.momut.ooas.ast.types.UlyssesType;
+import org.momut.ooas.ast.types.Type;
 import org.momut.ooas.utils.exceptions.ArgumentException;
 import org.momut.ooas.utils.exceptions.NotImplementedException;
 
@@ -46,11 +46,11 @@
 	protected IScope m_definingScope;
 	protected IdentifierKind m_identifierKind;
 	protected String m_tokenText;
-	protected UlyssesType m_Type;
+	protected Type m_Type;
 
 	// basic attributes of an Identifier
 	public final IdentifierKind kind() { return m_identifierKind; } // kind of identifier
-	public final UlyssesType type() { return m_Type; }   // type of identifier
+	public final Type type() { return m_Type; }   // type of identifier
 	public final IScope definingScope() { return m_definingScope; } // scope where it's defined
 
 	// from lexer
@@ -63,7 +63,7 @@
 
 
 	public Identifier(Token aToken,
-			UlyssesType aType,
+			Type aType,
 			IdentifierKind aKind,
 			IScope aDefiningScope)
 	{
@@ -75,7 +75,7 @@
 		m_definingScope = aDefiningScope;
 	}
 
-	public Identifier(String name, UlyssesType aType, IdentifierKind aKind, IScope aDefiningScope)
+	public Identifier(String name, Type aType, IdentifierKind aKind, IScope aDefiningScope)
 	{
 		m_tokenText = name;
 		m_line = 0;
@@ -107,7 +107,7 @@
 		throw new NotImplementedException();
 	}
 
-	public final void SetType(UlyssesType aType)
+	public final void SetType(Type aType)
 	{
 		if (aType == null)
 			throw new ArgumentException("New type can not be null.");
Index: trunk/compiler/ooasCompiler/src/org/momut/ooas/ast/identifiers/IdentifierKind.java
===================================================================
--- trunk/compiler/ooasCompiler/src/org/momut/ooas/ast/identifiers/IdentifierKind.java	(revision 8)
+++ trunk/compiler/ooasCompiler/src/org/momut/ooas/ast/identifiers/IdentifierKind.java	(revision 9)
@@ -31,7 +31,7 @@
 {
 	TypeIdentifier(0),               // some named type
 	EnumIdentifier(1),               // identifier of enumerated type
-	LandmarkIdentifier(2),           // landmark
+//	LandmarkIdentifier(2),           // landmark -- originally used for QR types, no longer supported.
 	AttributeIdentifier(3),          // global attribute
 	LocalVariableIdentifier(4),      // local variable
 	ParameterIdentifier(5),          // method/named action argument
Index: trunk/compiler/ooasCompiler/src/org/momut/ooas/ast/identifiers/LocalVariableIdentifier.java
===================================================================
--- trunk/compiler/ooasCompiler/src/org/momut/ooas/ast/identifiers/LocalVariableIdentifier.java	(revision 8)
+++ trunk/compiler/ooasCompiler/src/org/momut/ooas/ast/identifiers/LocalVariableIdentifier.java	(revision 9)
@@ -31,13 +31,13 @@
 import org.antlr.runtime.Token;
 import org.momut.ooas.ast.IAstVisitor;
 import org.momut.ooas.ast.IScope;
-import org.momut.ooas.ast.types.UlyssesType;
+import org.momut.ooas.ast.types.Type;
 
 
 public class LocalVariableIdentifier extends ValueReferenceIdentifier
 {
 	public LocalVariableIdentifier(Token aToken,
-			UlyssesType aType,
+			Type aType,
 			IScope aDefiningScope)
 	{
 		super (aToken, aType, IdentifierKind.LocalVariableIdentifier, aDefiningScope);
@@ -44,7 +44,7 @@
 	}
 
 	public LocalVariableIdentifier(String name,
-			UlyssesType aType,
+			Type aType,
 			IScope aDefiningScope)
 	{
 		super (name, aType, IdentifierKind.LocalVariableIdentifier, aDefiningScope);
@@ -61,7 +61,7 @@
 		return new LocalVariableIdentifier(this);
 	}
 
-	public LocalVariableIdentifier(String name, UlyssesType aType, IdentifierKind aKind, IScope aDefiningScope)
+	public LocalVariableIdentifier(String name, Type aType, IdentifierKind aKind, IScope aDefiningScope)
 	{
 		super (name, aType, aKind, aDefiningScope);
 	}
Index: trunk/compiler/ooasCompiler/src/org/momut/ooas/ast/identifiers/MethodIdentifier.java
===================================================================
--- trunk/compiler/ooasCompiler/src/org/momut/ooas/ast/identifiers/MethodIdentifier.java	(revision 8)
+++ trunk/compiler/ooasCompiler/src/org/momut/ooas/ast/identifiers/MethodIdentifier.java	(revision 9)
@@ -31,12 +31,12 @@
 import org.antlr.runtime.Token;
 import org.momut.ooas.ast.IAstVisitor;
 import org.momut.ooas.ast.IScope;
-import org.momut.ooas.ast.types.UlyssesType;
+import org.momut.ooas.ast.types.Type;
 
 public final class MethodIdentifier extends FunctionIdentifier
 {
 	public MethodIdentifier(Token aToken,
-			UlyssesType aType,
+			Type aType,
 			IScope aDefiningScope)
 	{
 		super (aToken, aType, IdentifierKind.MethodIdentifier, aDefiningScope);
@@ -43,7 +43,7 @@
 	}
 
 	public MethodIdentifier(String aName,
-			UlyssesType aType,
+			Type aType,
 			IScope aDefiningScope)
 	{
 		super (aName, aType, IdentifierKind.MethodIdentifier, aDefiningScope);
Index: trunk/compiler/ooasCompiler/src/org/momut/ooas/ast/identifiers/NamedActionIdentifier.java
===================================================================
--- trunk/compiler/ooasCompiler/src/org/momut/ooas/ast/identifiers/NamedActionIdentifier.java	(revision 8)
+++ trunk/compiler/ooasCompiler/src/org/momut/ooas/ast/identifiers/NamedActionIdentifier.java	(revision 9)
@@ -31,12 +31,12 @@
 import org.antlr.runtime.Token;
 import org.momut.ooas.ast.IAstVisitor;
 import org.momut.ooas.ast.IScope;
-import org.momut.ooas.ast.types.UlyssesType;
+import org.momut.ooas.ast.types.Type;
 
 public final class NamedActionIdentifier extends FunctionIdentifier
 {
 	public NamedActionIdentifier(Token aToken,
-			UlyssesType aType,
+			Type aType,
 			IScope aDefiningScope)
 	{
 		super (aToken, aType, IdentifierKind.NamedActionIdentifier, aDefiningScope);
@@ -43,7 +43,7 @@
 	}
 
 	public NamedActionIdentifier(String aName,
-			UlyssesType aType,
+			Type aType,
 			IScope aDefiningScope)
 	{
 		super (aName, aType, IdentifierKind.NamedActionIdentifier, aDefiningScope);
Index: trunk/compiler/ooasCompiler/src/org/momut/ooas/ast/identifiers/ParameterIdentifier.java
===================================================================
--- trunk/compiler/ooasCompiler/src/org/momut/ooas/ast/identifiers/ParameterIdentifier.java	(revision 8)
+++ trunk/compiler/ooasCompiler/src/org/momut/ooas/ast/identifiers/ParameterIdentifier.java	(revision 9)
@@ -30,12 +30,12 @@
 import org.antlr.runtime.Token;
 import org.momut.ooas.ast.IAstVisitor;
 import org.momut.ooas.ast.IScope;
-import org.momut.ooas.ast.types.UlyssesType;
+import org.momut.ooas.ast.types.Type;
 
 public final class ParameterIdentifier extends LocalVariableIdentifier
 {
 	public ParameterIdentifier(Token aToken,
-			UlyssesType aType,
+			Type aType,
 			IScope aDefiningScope)
 	{
 		super(aToken, aType, aDefiningScope);
@@ -42,7 +42,7 @@
 		m_identifierKind = IdentifierKind.ParameterIdentifier;
 	}
 
-	public ParameterIdentifier(String name, UlyssesType aType, IScope aDefiningScope)
+	public ParameterIdentifier(String name, Type aType, IScope aDefiningScope)
 	{
 		super (name, aType, IdentifierKind.ParameterIdentifier, aDefiningScope);
 	}
